from google.protobuf.internal import containers as _containers
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class Uuid(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class ContactId(_message.Message):
    __slots__ = ("uuid", "numeric_id", "handle")
    UUID_FIELD_NUMBER: _ClassVar[int]
    NUMERIC_ID_FIELD_NUMBER: _ClassVar[int]
    HANDLE_FIELD_NUMBER: _ClassVar[int]
    uuid: Uuid
    numeric_id: int
    handle: str
    def __init__(self, uuid: _Optional[_Union[Uuid, _Mapping]] = ..., numeric_id: _Optional[int] = ..., handle: _Optional[str] = ...) -> None: ...

class ContactHistoryId(_message.Message):
    __slots__ = ("uuid",)
    UUID_FIELD_NUMBER: _ClassVar[int]
    uuid: Uuid
    def __init__(self, uuid: _Optional[_Union[Uuid, _Mapping]] = ...) -> None: ...

class ContactHandle(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: str
    def __init__(self, value: _Optional[str] = ...) -> None: ...

class Identity(_message.Message):
    __slots__ = ("identity_provider", "subject")
    class IdentityProvider(_message.Message):
        __slots__ = ("value",)
        VALUE_FIELD_NUMBER: _ClassVar[int]
        value: str
        def __init__(self, value: _Optional[str] = ...) -> None: ...
    class Subject(_message.Message):
        __slots__ = ("value",)
        VALUE_FIELD_NUMBER: _ClassVar[int]
        value: str
        def __init__(self, value: _Optional[str] = ...) -> None: ...
    IDENTITY_PROVIDER_FIELD_NUMBER: _ClassVar[int]
    SUBJECT_FIELD_NUMBER: _ClassVar[int]
    identity_provider: Identity.IdentityProvider
    subject: Identity.Subject
    def __init__(self, identity_provider: _Optional[_Union[Identity.IdentityProvider, _Mapping]] = ..., subject: _Optional[_Union[Identity.Subject, _Mapping]] = ...) -> None: ...

class Date(_message.Message):
    __slots__ = ("year", "month", "day")
    YEAR_FIELD_NUMBER: _ClassVar[int]
    MONTH_FIELD_NUMBER: _ClassVar[int]
    DAY_FIELD_NUMBER: _ClassVar[int]
    year: int
    month: int
    day: int
    def __init__(self, year: _Optional[int] = ..., month: _Optional[int] = ..., day: _Optional[int] = ...) -> None: ...

class PlaceAddress(_message.Message):
    __slots__ = ("street", "city", "state_or_province", "postal_code", "country_code")
    STREET_FIELD_NUMBER: _ClassVar[int]
    CITY_FIELD_NUMBER: _ClassVar[int]
    STATE_OR_PROVINCE_FIELD_NUMBER: _ClassVar[int]
    POSTAL_CODE_FIELD_NUMBER: _ClassVar[int]
    COUNTRY_CODE_FIELD_NUMBER: _ClassVar[int]
    street: _containers.RepeatedScalarFieldContainer[str]
    city: str
    state_or_province: str
    postal_code: str
    country_code: str
    def __init__(self, street: _Optional[_Iterable[str]] = ..., city: _Optional[str] = ..., state_or_province: _Optional[str] = ..., postal_code: _Optional[str] = ..., country_code: _Optional[str] = ...) -> None: ...

class IdentityData(_message.Message):
    __slots__ = ("name", "birthdate", "address")
    NAME_FIELD_NUMBER: _ClassVar[int]
    BIRTHDATE_FIELD_NUMBER: _ClassVar[int]
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    name: str
    birthdate: Date
    address: PlaceAddress
    def __init__(self, name: _Optional[str] = ..., birthdate: _Optional[_Union[Date, _Mapping]] = ..., address: _Optional[_Union[PlaceAddress, _Mapping]] = ...) -> None: ...

class ContactDoesNotExist(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class ContactIsOrganization(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class HistoryIdMismatch(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class IdentityDoesNotExist(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class MissingContactId(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class LogEntryId(_message.Message):
    __slots__ = ("value",)
    VALUE_FIELD_NUMBER: _ClassVar[int]
    value: int
    def __init__(self, value: _Optional[int] = ...) -> None: ...
