from fred_api.identity import common_types_pb2 as _common_types_pb2
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class CheckCurrentContactDataRequest(_message.Message):
    __slots__ = ("contact_id", "contact_history_id", "auth_info", "name", "address", "birthdate")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    AUTH_INFO_FIELD_NUMBER: _ClassVar[int]
    NAME_FIELD_NUMBER: _ClassVar[int]
    ADDRESS_FIELD_NUMBER: _ClassVar[int]
    BIRTHDATE_FIELD_NUMBER: _ClassVar[int]
    contact_id: _common_types_pb2.ContactId
    contact_history_id: _common_types_pb2.ContactHistoryId
    auth_info: str
    name: str
    address: _common_types_pb2.PlaceAddress
    birthdate: _common_types_pb2.Date
    def __init__(self, contact_id: _Optional[_Union[_common_types_pb2.ContactId, _Mapping]] = ..., contact_history_id: _Optional[_Union[_common_types_pb2.ContactHistoryId, _Mapping]] = ..., auth_info: _Optional[str] = ..., name: _Optional[str] = ..., address: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., birthdate: _Optional[_Union[_common_types_pb2.Date, _Mapping]] = ...) -> None: ...

class CheckCurrentContactDataReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_history_id", "auth_info_matches", "name", "address", "birthdate", "broken_birthdate")
        CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
        AUTH_INFO_MATCHES_FIELD_NUMBER: _ClassVar[int]
        NAME_FIELD_NUMBER: _ClassVar[int]
        ADDRESS_FIELD_NUMBER: _ClassVar[int]
        BIRTHDATE_FIELD_NUMBER: _ClassVar[int]
        BROKEN_BIRTHDATE_FIELD_NUMBER: _ClassVar[int]
        contact_history_id: _common_types_pb2.ContactHistoryId
        auth_info_matches: bool
        name: str
        address: _common_types_pb2.PlaceAddress
        birthdate: _common_types_pb2.Date
        broken_birthdate: str
        def __init__(self, contact_history_id: _Optional[_Union[_common_types_pb2.ContactHistoryId, _Mapping]] = ..., auth_info_matches: bool = ..., name: _Optional[str] = ..., address: _Optional[_Union[_common_types_pb2.PlaceAddress, _Mapping]] = ..., birthdate: _Optional[_Union[_common_types_pb2.Date, _Mapping]] = ..., broken_birthdate: _Optional[str] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "history_id_mismatch", "missing_contact_id", "contact_is_organization")
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        HISTORY_ID_MISMATCH_FIELD_NUMBER: _ClassVar[int]
        MISSING_CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        CONTACT_IS_ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _common_types_pb2.ContactDoesNotExist
        history_id_mismatch: _common_types_pb2.HistoryIdMismatch
        missing_contact_id: _common_types_pb2.MissingContactId
        contact_is_organization: _common_types_pb2.ContactIsOrganization
        def __init__(self, contact_does_not_exist: _Optional[_Union[_common_types_pb2.ContactDoesNotExist, _Mapping]] = ..., history_id_mismatch: _Optional[_Union[_common_types_pb2.HistoryIdMismatch, _Mapping]] = ..., missing_contact_id: _Optional[_Union[_common_types_pb2.MissingContactId, _Mapping]] = ..., contact_is_organization: _Optional[_Union[_common_types_pb2.ContactIsOrganization, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: CheckCurrentContactDataReply.Data
    exception: CheckCurrentContactDataReply.Exception
    def __init__(self, data: _Optional[_Union[CheckCurrentContactDataReply.Data, _Mapping]] = ..., exception: _Optional[_Union[CheckCurrentContactDataReply.Exception, _Mapping]] = ...) -> None: ...
