from fred_api.identity import common_types_pb2 as _common_types_pb2
from google.protobuf import empty_pb2 as _empty_pb2
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class AttachIdentityRequest(_message.Message):
    __slots__ = ("contact_id", "contact_history_id", "identity", "identity_data")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    CONTACT_HISTORY_ID_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_DATA_FIELD_NUMBER: _ClassVar[int]
    contact_id: _common_types_pb2.ContactId
    contact_history_id: _common_types_pb2.ContactHistoryId
    identity: _common_types_pb2.Identity
    identity_data: _common_types_pb2.IdentityData
    def __init__(self, contact_id: _Optional[_Union[_common_types_pb2.ContactId, _Mapping]] = ..., contact_history_id: _Optional[_Union[_common_types_pb2.ContactHistoryId, _Mapping]] = ..., identity: _Optional[_Union[_common_types_pb2.Identity, _Mapping]] = ..., identity_data: _Optional[_Union[_common_types_pb2.IdentityData, _Mapping]] = ...) -> None: ...

class AttachIdentityReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "history_id_mismatch", "identity_attached", "contact_is_organization")
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        HISTORY_ID_MISMATCH_FIELD_NUMBER: _ClassVar[int]
        IDENTITY_ATTACHED_FIELD_NUMBER: _ClassVar[int]
        CONTACT_IS_ORGANIZATION_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _common_types_pb2.ContactDoesNotExist
        history_id_mismatch: _common_types_pb2.HistoryIdMismatch
        identity_attached: AttachIdentityReply.IdentityAttached
        contact_is_organization: _common_types_pb2.ContactIsOrganization
        def __init__(self, contact_does_not_exist: _Optional[_Union[_common_types_pb2.ContactDoesNotExist, _Mapping]] = ..., history_id_mismatch: _Optional[_Union[_common_types_pb2.HistoryIdMismatch, _Mapping]] = ..., identity_attached: _Optional[_Union[AttachIdentityReply.IdentityAttached, _Mapping]] = ..., contact_is_organization: _Optional[_Union[_common_types_pb2.ContactIsOrganization, _Mapping]] = ...) -> None: ...
    class IdentityAttached(_message.Message):
        __slots__ = ()
        def __init__(self) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: AttachIdentityReply.Exception
    def __init__(self, exception: _Optional[_Union[AttachIdentityReply.Exception, _Mapping]] = ...) -> None: ...

class DetachIdentityRequest(_message.Message):
    __slots__ = ("contact_id", "identity")
    CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_FIELD_NUMBER: _ClassVar[int]
    contact_id: _common_types_pb2.ContactId
    identity: _common_types_pb2.Identity
    def __init__(self, contact_id: _Optional[_Union[_common_types_pb2.ContactId, _Mapping]] = ..., identity: _Optional[_Union[_common_types_pb2.Identity, _Mapping]] = ...) -> None: ...

class DetachIdentityReply(_message.Message):
    __slots__ = ("exception",)
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist", "identity_does_not_exist")
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        IDENTITY_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _common_types_pb2.ContactDoesNotExist
        identity_does_not_exist: _common_types_pb2.IdentityDoesNotExist
        def __init__(self, contact_does_not_exist: _Optional[_Union[_common_types_pb2.ContactDoesNotExist, _Mapping]] = ..., identity_does_not_exist: _Optional[_Union[_common_types_pb2.IdentityDoesNotExist, _Mapping]] = ...) -> None: ...
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    exception: DetachIdentityReply.Exception
    def __init__(self, exception: _Optional[_Union[DetachIdentityReply.Exception, _Mapping]] = ...) -> None: ...

class UpdateIdentityRequest(_message.Message):
    __slots__ = ("identity", "identity_data", "log_entry_id")
    IDENTITY_FIELD_NUMBER: _ClassVar[int]
    IDENTITY_DATA_FIELD_NUMBER: _ClassVar[int]
    LOG_ENTRY_ID_FIELD_NUMBER: _ClassVar[int]
    identity: _common_types_pb2.Identity
    identity_data: _common_types_pb2.IdentityData
    log_entry_id: _common_types_pb2.LogEntryId
    def __init__(self, identity: _Optional[_Union[_common_types_pb2.Identity, _Mapping]] = ..., identity_data: _Optional[_Union[_common_types_pb2.IdentityData, _Mapping]] = ..., log_entry_id: _Optional[_Union[_common_types_pb2.LogEntryId, _Mapping]] = ...) -> None: ...

class GetContactIdByHandleRequest(_message.Message):
    __slots__ = ("contact_handle",)
    CONTACT_HANDLE_FIELD_NUMBER: _ClassVar[int]
    contact_handle: _common_types_pb2.ContactHandle
    def __init__(self, contact_handle: _Optional[_Union[_common_types_pb2.ContactHandle, _Mapping]] = ...) -> None: ...

class GetContactIdByHandleReply(_message.Message):
    __slots__ = ("data", "exception")
    class Data(_message.Message):
        __slots__ = ("contact_id",)
        CONTACT_ID_FIELD_NUMBER: _ClassVar[int]
        contact_id: _common_types_pb2.ContactId
        def __init__(self, contact_id: _Optional[_Union[_common_types_pb2.ContactId, _Mapping]] = ...) -> None: ...
    class Exception(_message.Message):
        __slots__ = ("contact_does_not_exist",)
        CONTACT_DOES_NOT_EXIST_FIELD_NUMBER: _ClassVar[int]
        contact_does_not_exist: _common_types_pb2.ContactDoesNotExist
        def __init__(self, contact_does_not_exist: _Optional[_Union[_common_types_pb2.ContactDoesNotExist, _Mapping]] = ...) -> None: ...
    DATA_FIELD_NUMBER: _ClassVar[int]
    EXCEPTION_FIELD_NUMBER: _ClassVar[int]
    data: GetContactIdByHandleReply.Data
    exception: GetContactIdByHandleReply.Exception
    def __init__(self, data: _Optional[_Union[GetContactIdByHandleReply.Data, _Mapping]] = ..., exception: _Optional[_Union[GetContactIdByHandleReply.Exception, _Mapping]] = ...) -> None: ...
